﻿/* code to test stat(2) */

#include <sys/stat.h>
#include <sys/syscall.h>
#include <stdio.h>

int main (int argc, char *argv[])
{
    struct stat s1;
    struct stat s2;
    if (argc < 2) {
        printf("path arg required\n");
        return 1;
    }

    printf("calling stat syscall directly:\n");
    if(syscall(SYS_stat, argv[1], &s1) == -1) {
        perror("stat syscall failed");
		return 1;
    }
    printf("path = %s\n", argv[1]);
    printf("s1.st_mode = %x\n", s1.st_mode);
    printf("S_ISDIR(s1.st_mode) = %d\n", S_ISDIR(s1.st_mode));

    printf("\ncalling stat function:\n");
    if(stat(argv[1], &s2) == -1) {
        perror("stat failed");
		return 1;
    }
    printf("path = %s\n", argv[1]);
    printf("s2.st_mode = %x\n", s2.st_mode);
    printf("S_ISDIR(s2.st_mode) = %d\n", S_ISDIR(s2.st_mode));

    return 0;
}
